/**
 * Revealing module for generating levels for the Filtering Game.
 * @module levelGeneratorFG
 * 
 * @returns {Object} - Contains the revealed functions: {@link module:levelGeneratorFG.initGenerator}, {@link module:levelGeneratorFG.setUrlGenerator}, {@link module:levelGeneratorFG.setUrlManager}, {@link module:levelGeneratorFG.createLevel} and {@link module:levelGeneratorFG.resetDefaults}
 */

/**
 * An object containg the information associated to a type.
 * 
 * @typedef {Object} Type
 * 
 * @property {String} captionKey - The caption key associated with the type in the game.
 * @property {String} descriptionKey - The description key associated with the type in the game.
 * @property {Integer} category - The category of the type. 1 represents phishing, 0 represents no-Phish.
 * @property {String} type - The identifier of the type.
 * @property {Integer} [numberOfUrls] - The number of URLs to be generated for this type.
 * @property {Boolean} [hasToBeContained] - Defines if a type has to be contained in the output. 
 */

/**
 * An object containing the type information required for a level.
 * 
 * @typedef {Object} TypeSettings
 * 
 * @property {Object} [types] - An object which contains the type data. Each key represents a type. Needs to be set if it has not been previously saved.
 * @property {Integer} [numberOfTypes] - Amount of types to be selected from the types array.
 * @property {Integer} [defaultNumberOfUrls] - The default amount of URLs that are generated per type if the numberOfUrls property was not set in .
 */

/**
 * The template for a level.
 *  All entries are optional (types in typeSettings may be needed if not set with overwriteDefaults!) when passed in as an input, but will be generated by the level generator.
 * 
 * @typedef {Object} LevelTemplate
 * 
 * @property {Integer} [amountActiveURLs] - The number of coins to be displayed simultaneously.
 * @property {Integer} [filterPoints] - The score required to beat the level.
 * @property {Integer} [timeLimit] - The available time in the level.
 * @property {String} [difficulty] - The difficulty of the level. Available options are easy and hard.
 * @property {Integer} [pointsForRightType] - The number of points the user receives when answering correctly.
 * @property {Integer} [pointsForRightTendency] - The number of points the user receives when the user recognizes a phishing URL, but not the type.
 * @property {Boolean} [overwriteDefaults] - Defines whether or not the default properties should be overwritten.
 * @property {TypeSettings} [typeSettings] - Contains the settings for type selection.
 */

/**
 * An object containing URL data. May have additional properties.
 * 
 * @typedef {Object} urlObject
 * 
 * @property {String} name - Name of the service associated with the URL.
 * @property {String} url - URL under which the service can be accessed.
 */

/**
 * An object containing URL data and phishing types. May have additional properties.
 * 
 * @typedef {Object} typeObject
 * 
 * @property {String} name - Name of the service supposedly associated with the URL.
 * @property {String} url - URL under which the service can supposedly be accessed.
 * @property {String} type - Name of the phishing type that was used to modify the URL.
 */

/**
 * A module that manages the learner profile of the user. Required functionality: {@link module:urlManager}.
 * 
 * @typedef {Module} urlManager
 * 
 * @see {@link module:urlManager}
 */

/**
 * A module that manages the url generation. Required functionality: {@link module:urlGenerator}.
 * 
 * @typedef {Module} urlGenerator
 * @see {@link module:urlGenerator}
 */

let levelGeneratorFG = (function(){
    // global variables to store references to the used URL-manager / -generator
    let generator;
    let manager;
    let isSelector = true; // added to give the option for passing names to the url selector

    let difficulties = ["easy", "hard"]; // list of existing difficulties
    let overwriteDefaults = false; // global variable, stores if entries in levelSettings overwrite entries in defaultValues 
    let newValues = {}; // stores values temporarily if overwriteDefaults is true; used in the end to overwrite defaultValues
    let levelSettings = {}; // global variable containing the level settings

    // fallback values if values are not specified, can be overwritten using overwriteDefaults
    let defaultValues = {
        'typeSettings' : {
            "numberOfTypes" : 2,
            "defaultNumberOfUrls" : 10,
        },
        "amountActiveURLs": 20,
        "filterPoints": 2000,
        "timeLimit" : 90,		
        "difficulty" : "easy", 
        "pointsForRightType": 500,
        "pointsForRightTendency": 200
    }


    /**
     * Used to initialize both the URL-Generator as well as the URL-Manager.
     * 
     * @param {urlGenerator} generator - The URL-Generator to be used.
     * @param {urlManager} manager- The URL-Manager to be used.
     * @memberof module:levelGeneratorFG
     */
    function initGenerator(generator, manager){
        setUrlGenerator(generator);
        setUrlManager(manager);
    }

    /**
     * Used to set the URL generator.
     * @param {urlGenerator} generator - The URL-Generator to be used.
     * @memberof module:levelGeneratorFG 
     */
    function setUrlGenerator(urlGenerator){
        generator = urlGenerator;
    }

    /**
     * Used to set the URL manager
     * @param {urlManager} manager - The URL-Manager to be used.
     * @memberof module:levelGeneratorFG 
     */
    function setUrlManager(urlManager){
        manager = urlManager;
    }

    /**
     * Used to create a level for the Filtering Game.
     * 
     * @param {LevelTemplate} settings - The settings for the level creation.
     * @returns {LevelTemplate} - The filled template for level creation.
     * @memberof module:levelGeneratorFG
     */
    function createLevel(settings = {}){

        // temporary, makes initialization beforehand unnecessary
        if(manager == null) manager = urlManager;
        if(generator == null) generator = urlSelector;

        // 1. Set the values for levelSettings and overwriteDefaults        
        // initialize the global level settings variable
        levelSettings = (settings != null) ? settings : {}; 
        
        // if overwriteDefaults was contained in levelSettings and set to true, enable overwriting of all parameters
        if('overwriteDefaults' in levelSettings && levelSettings.overwriteDefaults == true){
            overwriteDefaults = true;
            newValues = JSON.parse(JSON.stringify(defaultValues));
        }

        // 2. Calls setBaseValues to set the base value
        setBaseValues();
        // 3. Calls processTypeSettings 
        if(processTypeSettings()){
            // 4. If types are contained, selects types an generates the respective URLs
            selectTypes();
        }
        else {
            // If no types are contained, returns an error message
            overwriteDefaults = false;
            return "Error: types not contained and no types stored";
        }
        
        // 5. Overwrite the values if overwriteDefaults was true
        if(overwriteDefaults){
            defaultValues = newValues;
            overwriteDefaults = false;
        }

        // 6. Return the level
        return levelSettings;
    }

    /**
     * Sets amountActiveURLs, filterPoints, timeLimit, difficulty, pointsForRightType, pointsForRightTendency
     * @summary Sets the base values.
     * 
     * @memberof module:levelGeneratorFG
     */
    function setBaseValues(){
        levelSettings.amountActiveURLs = setProperty( 'amountActiveURLs', "", utils.isIntOverMin, 0);
        levelSettings.filterPoints = setProperty('filterPoints', "", utils.isIntOverMin, 0);
        levelSettings.timeLimit = setProperty('timeLimit', "", utils.isIntOverMin, 0);
        levelSettings.difficulty = setProperty('difficulty', "", utils.isValueInDomain, difficulties);
        levelSettings.pointsForRightType = setProperty('pointsForRightType', "", utils.isIntOverMin, 0);
        levelSettings.pointsForRightTendency = setProperty('pointsForRightTendency', "", utils.isIntOverMin, 0);
    }

    /**
     * Returns the value of the property at the given path from the level settings or, if not contained, the default values. 
     * 
     * @param {String} property - The property name as string.
     * @param {String} path - String in dot notation that denotes the route to the parent of the property, e.g. "example.value" to access levelSettings.example.value
     * @param {Function} check - Function that returns true / false, has the property value as first input
     * @param  {...any} [checkArgs] - Additional parameters that are passed into the check function.
     * @returns {*} - The value of the property at the given path from the level settings or, if not contained, the default values
     * @memberof module:levelGeneratorFG
     */
    function setProperty(property, path, check, ...checkArgs){
        let settings = utils.getByPath(levelSettings, path);
        let defaultValue = utils.getByPath(defaultValues, path);
        let newVal = utils.getByPath(newValues, path);
        if(property in settings && check(settings[property], ...checkArgs)){
            if(overwriteDefaults) {
                newVal[property] = settings[property];
            }
            return settings[property];
        }
        return defaultValue[property];
    }

   /**
    * Function to check if the property of an object is empty (not contained, null, [], {}).
    * 
    * @param {Object} base - Base object in which the parameter is searched. 
    * @param {String} property - The property that is supposed to be checked
    * @returns {Boolean} - True if the property of an object is empty (not contained, null, [], {})
    * @memberof module:levelGeneratorFG
    */
    function isEmpty(base, property){
        return (!(property in base) || base[property] == null || base[property] == {} || base[property] == []);
    }

    /**
     * Sets the values contained in typeSettings and checks if types of levelSettings / defaultValues contains elements.
     * 
     * @returns {Boolean} - True if types are contained in typeSettings / defaultValues, false if not.
     * @memberof module:levelGeneratorFG
     */
    function processTypeSettings(){
        // prevent levelSettings from being null 
        if(isEmpty(levelSettings, 'typeSettings')){
            levelSettings.typeSettings = {};
        }
        let typeSettings = levelSettings.typeSettings;

        // set the properties numberOfTypes and numberOfUrls
        typeSettings.numberOfTypes = setProperty('numberOfTypes', "typeSettings", utils.isIntOverMin, 1);
        typeSettings.defaultNumberOfUrls = setProperty('defaultNumberOfUrls', "typeSettings", utils.isIntOverMin, 0); 

        if ((isEmpty(typeSettings, 'types')) && (isEmpty(defaultValues, 'typeSettings') || isEmpty(defaultValues.typeSettings, 'types'))){
            return false;
        }
        else if ((isEmpty(typeSettings, 'types')) && (!isEmpty(defaultValues, 'typeSettings') && !isEmpty(defaultValues.typeSettings, 'types'))){
            typeSettings.types = JSON.parse(JSON.stringify(defaultValues.typeSettings.types)); // TODO: quick and dirty deep copy
        }

        if(overwriteDefaults){
            newValues.typeSettings.types = JSON.parse(JSON.stringify(typeSettings.types));
        }
        return true;
    }
    
    /**
     * Selects the types for which URLs will be generated in the end. Guaranteed to select types contained in URLs and types with the property hasToBeContained set to true. Calls {@link module:levelGeneratorFG.generateUrls} in the end.
     * 
     * @memberof module:levelGeneratorFG
     */
    function selectTypes(){
        let typeSettings = levelSettings.typeSettings;
        let selectedTypes = [];
        let URLs = {};

        let currentNumberOfTypes = 0;
        let currentUrlNumberByType = [];
        let numberOfTypes = typeSettings.numberOfTypes;

        let types = typeSettings.types;
        let existingTypes = Object.keys(types);

        //  1. Check if URLs contains entries  
        if(!isEmpty(levelSettings, 'URLs')){
            // => yes: check if the type is contained in types and entry contains information
            URLs = levelSettings.URLs;
            let typesInUrls = Object.keys(URLs);
            for(type of typesInUrls){
                // => yes: add type to selected types
                if(existingTypes.includes(type) && !isEmpty(URLs, type)){
                    addType(selectedTypes, type, currentUrlNumberByType, URLs[type].length);
                    currentNumberOfTypes++;
                }
                else { 
                    // => no: delete entry from URLs 
                    delete URLs[type];
                }
            }
        }
        else levelSettings.URLs = {};

        // 2. Add the types to final output
        // Add types with the parameter hasToBeContained set to true
        for(type of existingTypes){
            if("hasToBeContained" in types[type] && types[type].hasToBeContained == true && !(selectedTypes.includes(type))){
                addType(selectedTypes, type, currentUrlNumberByType, 0);
                currentNumberOfTypes++;
            }
        }

        // Randomly select new entries, either all of them if numberOfTypes is greater or equal the amount of entries in types
        // or a random subset if numberOfTypes is smaller
        for(var i = currentNumberOfTypes; i < Math.min(numberOfTypes, existingTypes.length); i++){
            let remainingTypes = existingTypes.filter(e => !selectedTypes.includes(e));
            let newType = remainingTypes[utils.generateRandomIntBetween(0,remainingTypes.length-1)];
            addType(selectedTypes, newType, currentUrlNumberByType, 0);
        }

        // delete the types that were not selected
        for(type of existingTypes){
            if(!(selectedTypes.includes(type))){
                delete types[type];
            }
        }

        // 3. Generate URLs for selected types
        generateUrls(selectedTypes, currentUrlNumberByType);
    }

    /**
     * Generates URLs for each type contained in selected types and adds them to the template. Calls {@link module:urlManager.getUrl} and {@link module:urlGenerator.generateUrl}
     * 
     * @param {String[]} selectedTypes - Array of the selected types
     * @param {Integer[]} currentUrlNumberByType - Array containing the number of currently exxisting URLs for each type. 
     * @memberof module:levelGeneratorFG
     * 
     * 
     */
    function generateUrls(selectedTypes, currentUrlNumberByType){
        let types = levelSettings.typeSettings.types;
        let URLs = isEmpty(levelSettings, "URLs") ? {} : levelSettings.URLs;

        
        for(var i = 0; i < selectedTypes.length; i++) {
            // for each type, check if URLs already contained an entry
            if(isEmpty(URLs, selectedTypes[i])){
                // if not, add an empty entry
                URLs[selectedTypes[i]] = [];
            }
            // generate new Urls and append them to the array associated with the type in URLs
            for (var j = currentUrlNumberByType[i]; j < types[selectedTypes[i]].numberOfUrls; j++) {
                URLs[selectedTypes[i]].push(generateUrl(selectedTypes[i], manager.getUrl()));
            }
        }
    }

    /**
     * Generates a URL-object based on the given type and urlObject. If generation rules exist for the type, they are passed to the generator.
     * @param {String} type - The input type.
     * @param {urlObject} urlObject - The input urlObject.
     * @returns {urlObject} - The generated urlObject.
     */
    function generateUrl(type, urlObject){
        let urlEntry = {};

        if("rules" in levelSettings.typeSettings.types[type]){
            urlEntry = {
                "content" : urlObject.name,
                "url" : generator.generateUrl(levelSettings.typeSettings.types[type].rules, urlObject.url),
                "type" : type,
            }
        }
        else if(isSelector == true){
            let selectedElement = urlSelector.getUrlForType(type);
            urlEntry = {
                ...selectedElement,
                "type" : type,
            }
        }
        else {
            urlEntry = {
                "content" : urlObject.name,
                "url" : generator.generateUrl(type, urlObject.url),
                "type" : type,
            }
        }
        
        // add additional keys to the object
        for(key of Object.keys(urlObject)){
            if(key != "content" && key != "name" && key != "url" && key != "type"){
                urlEntry[key] = urlObject[key];
            }
        }
        return urlEntry;
    }

    /**
     * Sets the base data for a newly created type, adds it to the list of selected types and sets the value. 
     * 
     * @param {String[]} selectedTypes - The list of currently selected types.
     * @param {String} type - The type that is supposed to be added.
     * @param {Integer[]} currentUrlNumberByType - The list containing the currently existing URL number by type.
     * @param {Integer} currentUrlNumber - The number of already existing URLs for the newly added type.
     * @memberof module:levelGeneratorFG
     */
    function addType(selectedTypes, type, currentUrlNumberByType, currentUrlNumber){
        let types = levelSettings.typeSettings.types;
        selectedTypes.push(type);
        if(!("numberOfUrls" in types[type]) || !(utils.isIntOverMin(types[type].numberOfUrls,0))) {
            types[type].numberOfUrls = levelSettings.typeSettings.defaultNumberOfUrls;
        }
        currentUrlNumberByType.push(currentUrlNumber);
    }

    /**
     * Resets defaultValues to its default value.
     * @memberof module:levelGeneratorFG
     */
    function resetDefaults(){
        defaultValues = {
            'typeSettings' : {
                "numberOfTypes" : 2,
                "defaultNumberOfUrls" : 10,
            },
            "amountActiveURLs": 20,
            "filterPoints": 2000,
            "timeLimit" : 90,		
            "difficulty" : "easy", 
            "pointsForRightType": 500,
            "pointsForRightTendency": 200
        }
    }

    return {
        initGenerator : initGenerator, 
        setUrlGenerator : setUrlGenerator,
        setUrlManager : setUrlManager,
        createLevel : createLevel,
        resetDefaults : resetDefaults
    }
})();

if (typeof exports !== 'undefined') {
    module.exports = levelGeneratorFG;
}